#!/bin/sh
#
# $Id: kill-by-name.sh,v 1.1.1.1 2000/09/15 02:29:41 how195 Exp $
#
# This script will kill all process with the program name provided
# as an argument.
# * Should work under both Solaris and Linux unmodified.
#

if [ $# -eq 0 ]; then
	echo ""
	echo "Kill by program name."
	echo "Usage: $0 <program name>"
	echo ""
	exit 1
fi

kill_by_name()
{
	if [ $# -eq 0 ]; then
		return
	fi

	sys=`uname -s`
	if [ "$sys" = "SunOS" ]; then
		PSCMD="ps -u$USER"
	elif [ "$sys" = "Linux" ]; then
		PSCMD="ps -u$USER"
	else
		echo "Don't know how to run ps under sys = $sys"
		exit 1
	fi

	$PSCMD > /tmp/kill.$$
	PIDS=`grep $1 /tmp/kill.$$ | awk '/[0-9]+/ { print $1 }'`
	for pid in $PIDS; do
		running=`$PSCMD | grep $pid`
		if [ "$running" != "" -a "$$" != "$pid" ]; then
			kill -9 $pid
		fi
	done
	rm -f /tmp/kill.$$
}

kill_by_name $1
